#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Quelques exemples pour traiter une vidéo

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Télécharger une vidéo
# 
# [outils](http://www.xavierdupre.fr/app/code_beatrix/helpsphinx/api/video.html#youtube)

# In[2]:


from code_beatrix.art.video import *


# In[3]:


download_youtube_video('Htaj3o3JD8I', '.', res=None)


# La librairie [librosa](https://librosa.github.io/librosa_gallery/index.html) permet de retraiter le son comme de séparer les voix du fond sonore.

# ## Extraire le son

# In[4]:


son = video_extract_audio('Harry Potter Theme Song.mp4')


# In[5]:


son30 = audio_extract_audio(son, '00:00:00', '00:00:30')


# ## Jouer le son

# In[6]:


son30.ipython_display()


# ## Liste des vidéos filmées

# In[7]:


import os
[_ for _ in os.listdir(r'.') if 'mp4' in _ and ('Harry' in _ or "WIN_20180113_16" in _)]


# ## Extraire un bout de la video
# 
# J'ai perdu la vidéo qui me servait d'exemple, donc j'en prends une autre hasard mais le principe reste le même.

# In[8]:


from pyensae.datasource import download_data
vidfile = download_data("gonzague_van_bervesseles_traitement_donnees.mp4")


# In[9]:


vid = video_extract_video(vidfile, '00:00:06', '00:00:22')


# ## Accélérer une vidéo

# In[10]:


vid2 = video_modification(vid, speed=2.)


# ## Mettre des vidéos bout à bout

# In[11]:


video_mur = video_concatenate([vid2, vid])


# ## Mettre des sons bout à bout

# In[12]:


son3 = audio_concatenate([son30, son30])


# ## Remplacer le son d'une vidéo

# In[13]:


video_truquee = video_replace_audio(video_mur, son3)


# ## Sauver une vidéo sur disque

# In[14]:


video_save(video_truquee, 'rapide_crash2_truquee2.mp4', verbose=True)


# In[15]: